/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import { IconCheckSolid, IconArrowOpenEndSolid } from '@instructure/ui-icons';
import { Options } from '../index';
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
export default {
  maxExamplesPerPage: 50,
  propValues: {
    children: [[_jsx(Options.Item, {
      children: "Option one"
    }, "option-1"), _jsx(Options.Item, {
      variant: "highlighted",
      children: "Option two"
    }, "option-2"), _jsx(Options.Item, {
      variant: "selected",
      children: "Option three"
    }, "option-3"), _jsx(Options.Item, {
      variant: "disabled",
      children: "Option four"
    }, "option-4")], [_jsx(Options.Item, {
      variant: "highlighted",
      renderAfterLabel: IconArrowOpenEndSolid,
      children: "Flyout menu option"
    }, "option-1"), _jsx(Options.Item, {
      children: "Option one"
    }, "option-2"), _jsx(Options.Separator, {}, "sep-1"), _jsxs(Options, {
      renderLabel: 'Sub list',
      children: [_jsx(Options.Item, {
        variant: "selected",
        children: "Sub option one"
      }), _jsx(Options.Item, {
        children: "Sub option two"
      })]
    }, "sub-list"), _jsx(Options.Separator, {}, "sep-2"), _jsxs(Options, {
      renderLabel: 'Icon List',
      children: [_jsx(Options.Item, {
        renderBeforeLabel: IconCheckSolid,
        children: "Icon option one"
      }), _jsx(Options.Item, {
        renderBeforeLabel: _jsx(IconCheckSolid, {
          style: {
            opacity: 0
          }
        }),
        children: "Icon option two"
      })]
    }, "icon-list"), _jsx(Options.Separator, {}, "sep-3"), _jsx(Options.Item, {
      children: "Option two"
    }, "option-3")]]
  }
};