import { Component } from 'react';
import type { OptionsItemProps, OptionsItemStyle } from './props';
/**
---
parent: Options
id: Options.Item
---
**/
declare class Item extends Component<OptionsItemProps> {
    static readonly componentId = "Options.Item";
    static allowedProps: readonly ("elementRef" | "href" | keyof import("./props").OptionsItemRenderProps | "renderBeforeLabel" | "renderAfterLabel" | "beforeLabelContentVAlign" | "afterLabelContentVAlign" | "description" | "descriptionRole" | "voiceoverRoleBugWorkaround" | "isSelected")[];
    static propTypes: import("@instructure/shared-types").PropValidators<"elementRef" | "href" | keyof import("./props").OptionsItemRenderProps | "renderBeforeLabel" | "renderAfterLabel" | "beforeLabelContentVAlign" | "afterLabelContentVAlign" | "description" | "descriptionRole" | "voiceoverRoleBugWorkaround" | "isSelected">;
    static defaultProps: {
        readonly as: "span";
        readonly variant: "default";
        readonly role: "listitem";
        readonly voiceoverRoleBugWorkaround: false;
        readonly beforeLabelContentVAlign: "center";
        readonly afterLabelContentVAlign: "center";
        readonly isSelected: false;
    };
    ref: Element | null;
    private readonly _descriptionId;
    constructor(props: OptionsItemProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    renderContent(renderLabel: OptionsItemProps['renderBeforeLabel'] | OptionsItemProps['renderAfterLabel'], contentVariant: OptionsItemStyle['contentBefore'] | OptionsItemStyle['contentAfter']): import("@emotion/react/jsx-runtime").JSX.Element;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Item;
export { Item };
//# sourceMappingURL=index.d.ts.map