import { ComponentElement, Component } from 'react';
import { Item } from './Item';
import { Separator } from './Separator';
import type { OptionsProps } from './props';
type OptionsChild = ComponentElement<OptionsProps, Options>;
/**
---
category: components
---
**/
declare class Options extends Component<OptionsProps> {
    static readonly componentId = "Options";
    static allowedProps: readonly (keyof {
        as?: import("@instructure/shared-types").AsElementType;
        role?: string;
        elementRef?: (element: Element | null) => void;
        renderLabel?: import("@instructure/shared-types").Renderable;
        children?: React.ReactNode;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        as?: import("@instructure/shared-types").AsElementType;
        role?: string;
        elementRef?: (element: Element | null) => void;
        renderLabel?: import("@instructure/shared-types").Renderable;
        children?: React.ReactNode;
    }>;
    static defaultProps: {
        as: string;
        role: string;
        elementRef: () => void;
        renderLabel: null;
        children: null;
    };
    static Item: typeof Item;
    static Separator: typeof Separator;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    _labelId: string;
    get childAs(): "li" | undefined;
    renderLabel(): import("@emotion/react/jsx-runtime").JSX.Element;
    renderSubList(subOptions: OptionsChild): import("@emotion/react/jsx-runtime").JSX.Element;
    renderChildren(): import("@emotion/react/jsx-runtime").JSX.Element[];
    get ariaLabelledby(): string | undefined;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Options;
export { Options };
//# sourceMappingURL=index.d.ts.map