import React from 'react';
import type { AsElementType, PropValidators, OptionsTheme, OtherHTMLAttributes } from '@instructure/shared-types';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
import type { WithDeterministicIdProps } from '@instructure/ui-react-utils';
import { Renderable } from '@instructure/shared-types';
type OptionsOwnProps = {
    /**
     * Element type to render as
     */
    as?: AsElementType;
    /**
     * The aria role of the element
     */
    role?: string;
    /**
     * The the actual list element
     */
    elementRef?: (element: Element | null) => void;
    /**
     * Content to render as a label. Mostly for when the component is nested
     */
    renderLabel?: Renderable;
    children?: React.ReactNode;
};
type PropKeys = keyof OptionsOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type OptionsProps = OptionsOwnProps & WithStyleProps<OptionsTheme, OptionsStyle> & OtherHTMLAttributes<OptionsOwnProps> & WithDeterministicIdProps;
type OptionsStyle = ComponentStyle<'options' | 'list' | 'label'>;
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { OptionsProps, OptionsStyle };
export { propTypes, allowedProps };
//# sourceMappingURL=props.d.ts.map